Skip to main content

Networking

View as Markdown

Create Account Ip Access List GA

POST /api/2.0/accounts/{account_id}/ip-access-lists

Creates an IP access list for the account.

A list can be an allow list or a block list. See the top of this file for a description of how the server treats allow lists and block lists at runtime.

When creating or updating an IP access list:

  • For all allow lists and block lists combined, the API supports a maximum of 1000 IP/CIDR values, where one CIDR counts as a single value. Attempts to exceed that number return error 400 with error_code value QUOTA_EXCEEDED.
  • If the new list would block the calling user's current IP, error 400 is returned with error_code value INVALID_STATE.

It can take a few minutes for the changes to take effect.

API scopes: networking

Parameters

account_idstringpath

Request body

labelstring

Example: Office VPN

list_typestring

Values: ALLOW, BLOCK

ip_addressesarray of string

Example: 192.168.100.0/22

Response

ip_access_listobject
Show child attributesHide child attributes
list_idstring

Universally unique identifier (UUID) of the IP access list.

labelstring

Label for the IP access list. This cannot be empty.

Example: Office VPN

ip_addressesarray of string

Example: 192.168.100.0/22

address_countint32

Total number of IP or CIDR values.

Example: 2

list_typestring

Values: ALLOW, BLOCK

created_atint64

Creation timestamp in milliseconds.

Example: 1580265020299

created_byint64

The ID of the user that created this list.

Example: 202480738464078

updated_atint64

Update timestamp in milliseconds.

Example: 1580265020299

updated_byint64

The ID of the user that last updated this list.

Example: 202480738464089

enabledboolean

Specifies whether this IP access list is enabled.

Delete Account Ip Access List GA

DELETE /api/2.0/accounts/{account_id}/ip-access-lists/{list_id}

Deletes an IP access list, specified by its list ID.

API scopes: networking

Parameters

account_idstringpath
list_idstringpath

The ID for the corresponding IP access list

Get Account Ip Access List GA

GET /api/2.0/accounts/{account_id}/ip-access-lists/{list_id}

Gets an IP access list, specified by its list ID.

API scopes: networking

Parameters

account_idstringpath
list_idstringpath

The ID for the corresponding IP access list

Response

ip_access_listobject
Show child attributesHide child attributes
list_idstring

Universally unique identifier (UUID) of the IP access list.

labelstring

Label for the IP access list. This cannot be empty.

Example: Office VPN

ip_addressesarray of string

Example: 192.168.100.0/22

address_countint32

Total number of IP or CIDR values.

Example: 2

list_typestring

Values: ALLOW, BLOCK

created_atint64

Creation timestamp in milliseconds.

Example: 1580265020299

created_byint64

The ID of the user that created this list.

Example: 202480738464078

updated_atint64

Update timestamp in milliseconds.

Example: 1580265020299

updated_byint64

The ID of the user that last updated this list.

Example: 202480738464089

enabledboolean

Specifies whether this IP access list is enabled.

List Account Ip Access Lists GA

GET /api/2.0/accounts/{account_id}/ip-access-lists

Gets all IP access lists for the specified account.

API scopes: networking

Parameters

account_idstringpath

Response

ip_access_listsarray of object
Show child attributesHide child attributes
list_idstring

Universally unique identifier (UUID) of the IP access list.

labelstring

Label for the IP access list. This cannot be empty.

Example: Office VPN

ip_addressesarray of string

Example: 192.168.100.0/22

address_countint32

Total number of IP or CIDR values.

Example: 2

list_typestring

Values: ALLOW, BLOCK

created_atint64

Creation timestamp in milliseconds.

Example: 1580265020299

created_byint64

The ID of the user that created this list.

Example: 202480738464078

updated_atint64

Update timestamp in milliseconds.

Example: 1580265020299

updated_byint64

The ID of the user that last updated this list.

Example: 202480738464089

enabledboolean

Specifies whether this IP access list is enabled.

Replace Account Ip Access List GA

PUT /api/2.0/accounts/{account_id}/ip-access-lists/{list_id}

Replaces an IP access list, specified by its ID.

A list can include allow lists and block lists. See the top of this file for a description of how the server treats allow lists and block lists at run time. When replacing an IP access list:

  • For all allow lists and block lists combined, the API supports a maximum of 1000 IP/CIDR values, where one CIDR counts as a single value. Attempts to exceed that number return error 400 with error_code value QUOTA_EXCEEDED.
  • If the resulting list would block the calling user's current IP, error 400 is returned with error_code value INVALID_STATE. It can take a few minutes for the changes to take effect.

API scopes: networking

Parameters

account_idstringpath
list_idstringpath

The ID for the corresponding IP access list

Request body

labelstring

Label for the IP access list. This cannot be empty.

Example: Office VPN

list_typestring

Values: ALLOW, BLOCK

ip_addressesarray of string

Example: 192.168.100.0/22

enabledboolean

Specifies whether this IP access list is enabled.

Response

ip_access_listobject
Show child attributesHide child attributes
list_idstring

Universally unique identifier (UUID) of the IP access list.

labelstring

Label for the IP access list. This cannot be empty.

Example: Office VPN

ip_addressesarray of string

Example: 192.168.100.0/22

address_countint32

Total number of IP or CIDR values.

Example: 2

list_typestring

Values: ALLOW, BLOCK

created_atint64

Creation timestamp in milliseconds.

Example: 1580265020299

created_byint64

The ID of the user that created this list.

Example: 202480738464078

updated_atint64

Update timestamp in milliseconds.

Example: 1580265020299

updated_byint64

The ID of the user that last updated this list.

Example: 202480738464089

enabledboolean

Specifies whether this IP access list is enabled.

Update Account Ip Access List GA

PATCH /api/2.0/accounts/{account_id}/ip-access-lists/{list_id}

Updates an existing IP access list, specified by its ID.

A list can include allow lists and block lists. See the top of this file for a description of how the server treats allow lists and block lists at run time.

When updating an IP access list:

  • For all allow lists and block lists combined, the API supports a maximum of 1000 IP/CIDR values, where one CIDR counts as a single value. Attempts to exceed that number return error 400 with error_code value QUOTA_EXCEEDED.
  • If the updated list would block the calling user's current IP, error 400 is returned with error_code value INVALID_STATE.

It can take a few minutes for the changes to take effect.

API scopes: networking

Parameters

account_idstringpath
list_idstringpath

The ID for the corresponding IP access list

Request body

labelstring

Label for the IP access list. This cannot be empty.

Example: Office VPN

list_typestring

Values: ALLOW, BLOCK

ip_addressesarray of string

Example: 192.168.100.0/22

enabledboolean

Specifies whether this IP access list is enabled.

Response

ip_access_listobject
Show child attributesHide child attributes
list_idstring

Universally unique identifier (UUID) of the IP access list.

labelstring

Label for the IP access list. This cannot be empty.

Example: Office VPN

ip_addressesarray of string

Example: 192.168.100.0/22

address_countint32

Total number of IP or CIDR values.

Example: 2

list_typestring

Values: ALLOW, BLOCK

created_atint64

Creation timestamp in milliseconds.

Example: 1580265020299

created_byint64

The ID of the user that created this list.

Example: 202480738464078

updated_atint64

Update timestamp in milliseconds.

Example: 1580265020299

updated_byint64

The ID of the user that last updated this list.

Example: 202480738464089

enabledboolean

Specifies whether this IP access list is enabled.

List Network Connectivity Configs Public GA

GET /api/2.0/accounts/{account_id}/network-connectivity-configs

Gets an array of network connectivity configurations.

API scopes: networking

Parameters

account_idstringpath

Your <Databricks> account ID. You can find your account ID in your <Databricks> accounts console.

page_tokenstringquery

Pagination token to go to next page based on previous query.

Response

itemsarray of object
Show child attributesHide child attributes
network_connectivity_config_idstring

<Databricks> network connectivity configuration ID.

Example: d6df3889-eefc-4ddb-bbb4-613efcb30035

account_idstring

Your <Databricks> account ID. You can find your account ID in your <Databricks> accounts console.

Example: 449e7a5c-69d3-4b8a-aaaf-5c9b713ebc65

namestring

The name of the network connectivity configuration. The name can contain alphanumeric characters, hyphens, and underscores. The length must be between 3 and 30 characters. The name must match the regular expression ^[0-9a-zA-Z-_]{3,30}$

Example: my-example-ncc

regionstring

The region for the network connectivity configuration. Only workspaces in the same region can be attached to the network connectivity configuration.

egress_configobject

The network connectivity rules that apply to network traffic from your serverless compute resources.

Show child attributesHide child attributes
default_rulesobject

The network connectivity rules that are applied by default without resource specific configurations. You can find the stable network information of your serverless compute resources here.

Show child attributesHide child attributes
azure_service_endpoint_ruleobject
aws_stable_ip_ruleobject
target_rulesobject

The network connectivity rules that configured for each destinations. These rules override default rules.

Show child attributesHide child attributes
azure_private_endpoint_rulesarray of object
aws_private_endpoint_rulesarray of object

AWS private endpoint rule controls the AWS private endpoint based egress rules.

updated_timeint64

Time in epoch milliseconds when this object was updated.

Example: 1691436121777

creation_timeint64

Time in epoch milliseconds when this object was created.

Example: 1691436121706

next_page_tokenstring

A token that can be used to get the next page of results. If null, there are no more results to show.

List Ncc Private Endpoint Rules GA

GET /api/2.0/accounts/{account_id}/network-connectivity-configs/{network_connectivity_config_id}/private-endpoint-rules

Gets an array of private endpoint rules.

API scopes: networking

Parameters

account_idstringpath

Your <Databricks> account ID. You can find your account ID in your <Databricks> accounts console.

network_connectivity_config_idstringpath

Your Network Connectvity Configuration ID.

page_tokenstringquery

Pagination token to go to next page based on previous query.

Response

itemsarray of object
Show child attributesHide child attributes
rule_idstring

The ID of a private endpoint rule.

Example: 728c1541-d6d1-4290-9a53-cdf01dd32d60

network_connectivity_config_idstring

The ID of a network connectivity configuration, which is the parent resource of this private endpoint rule object.

Example: d6df3889-eefc-4ddb-bbb4-613efcb30035

connection_statestring

The current status of this private endpoint. The private endpoint rules are effective only if the connection state is ESTABLISHED. Remember that you must approve new endpoints on your resources in the Cloud console before they take effect. The possible values are:

  • PENDING: The endpoint has been created and pending approval.
  • ESTABLISHED: The endpoint has been approved and is ready to use in your serverless compute resources.
  • REJECTED: Connection was rejected by the private link resource owner.
  • DISCONNECTED: Connection was removed by the private link resource owner, the private endpoint becomes informative and should be deleted for clean-up.
  • EXPIRED: If the endpoint was created but not approved in 14 days, it will be EXPIRED.
  • CREATING: The endpoint creation is in progress. Once successfully created, the state will transition to PENDING.
  • CREATE_FAILED: The endpoint creation failed. You can check the error_message field for more details.

Values: PRIVATE_LINK_CONNECTION_STATE_UNSPECIFIED, ESTABLISHED, REJECTED, DISCONNECTED, EXPIRED, PENDING, CREATING, CREATE_FAILED

Example: ESTABLISHED

domain_namesarray of string

Only used by private endpoints to customer-managed private endpoint services.

Domain names of target private link service. When updating this field, the full list of target domain_names must be specified.

AWS

Only used by private endpoints towards a VPC endpoint service behind a customer-managed VPC endpoint service.

The target AWS resource FQDNs accessible via the VPC endpoint service. When updating this field, we perform full update on this field. Please ensure a full list of desired domain_names is provided.

Example: my-example.exampledomain.com

creation_timeint64

Time in epoch milliseconds when this object was created.

Example: 1691436121706

updated_timeint64

Time in epoch milliseconds when this object was updated.

Example: 1691436121777

deactivatedboolean

Whether this private endpoint is deactivated.

Example: false

deactivated_atint64

Time in epoch milliseconds when this object was deactivated.

Example: 1691436121706

error_messagestring

Example: NOT_FOUND: The provided resource <input-resource> could not be found.

resource_idstring

The Azure resource ID of the target resource.

group_idstring

Not used by customer-managed private endpoint services.

The sub-resource type (group ID) of the target resource. Note that to connect to workspace root storage (root DBFS), you need two endpoints, one for blob and one for dfs.

Example: blob

endpoint_namestring

The name of the Azure private endpoint resource.

Example: databricks-088781b3-77fa-4132-b429-1af0d91bc593-pe-3cb31234

account_idstring

<Databricks> account ID. You can find your account ID from the Accounts Console.

Example: 449e7a5c-69d3-4b8a-aaaf-5c9b713ebc65

endpoint_servicestring

The full target AWS endpoint service name that connects to the destination resources of the private endpoint.

Example: com.amazonaws.vpce.us-east-1.vpce-svc-123abcc1298abc123

resource_namesarray of string

Only used by private endpoints towards AWS S3 service.

The globally unique S3 bucket names that will be accessed via the VPC endpoint. The bucket names must be in the same region as the NCC/endpoint service. When updating this field, we perform full update on this field. Please ensure a full list of desired resource_names is provided.

Example: mybucket1

vpc_endpoint_idstring

The AWS VPC endpoint ID. You can use this ID to identify the VPC endpoint created by <Databricks>.

Example: vpce-02c2bd4e6dcd6c76d

enabledboolean

Update this field to activate/deactivate this private endpoint to allow egress access from serverless compute resources. Only honored for first-party services on each cloud (e.g. AWS S3).

Example: true

gcp_endpointobjectRequiredPublic Preview
Show child attributesHide child attributes
psc_endpoint_uristringPublic Preview

Output only. The URI of the created PSC endpoint.

Example: projects/databricks-egress/regions/us-east4/forwardingRules/1234567890

service_attachmentstringRequiredPublic Preview

The full url of the target service attachment. Example: projects/my-gcp-project/regions/us-east4/serviceAttachments/my-service-attachment

Example: projects/my-gcp-project/regions/us-east4/serviceAttachments/my-service-attachment

next_page_tokenstring

A token that can be used to get the next page of results. If null, there are no more results to show.

List Network Public GA

GET /api/2.0/accounts/{account_id}/networks

Lists <Databricks> network configurations for an account.

API scopes: networking

CloudsAWSGCP

Parameters

account_idstringpath

Response

networksarray of object
Show child attributesHide child attributes
network_idstring

The <Databricks> network configuration ID.

account_idstring

The <Databricks> account ID associated with this network configuration.

workspace_idint64

Workspace ID associated with this network configuration.

Example: 1614665312930232

vpc_idstring

The ID of the VPC associated with this network configuration. VPC IDs can be used in multiple networks.

subnet_idsarray of string

IDs of at least two subnets associated with this network. Subnet IDs cannot be used in multiple network configurations.

security_group_idsarray of string

IDs of one to five security groups associated with this network. Security group IDs cannot be used in multiple network configurations.

Constraints: [ 1 .. 5 ] characters

vpc_statusstring

Values: VALID, BROKEN, UNATTACHED, WARNED

error_messagesarray of object

Array of error messages about the network configuration.

Show child attributesHide child attributes
error_typestring
error_messagestring

Details of the error.

network_namestring

The human-readable name of the network configuration.

Constraints: [ 4 .. 256 ] characters

creation_timeint64

Time in epoch milliseconds when the network was created.

warning_messagesarray of object

Array of warning messages about the network configuration.

Show child attributesHide child attributes
warning_typestring
warning_messagestring

Details of the warning.

vpc_endpointsobject
Show child attributesHide child attributes
rest_apiarray of string

The VPC endpoint ID used by this network to access the Databricks REST API.

dataplane_relayarray of string

The VPC endpoint ID used by this network to access the <Databricks> secure cluster connectivity relay.

gcp_network_infoobjectRequired
Show child attributesHide child attributes
network_project_idstring

The GCP project ID for network resources. This project is where the VPC and subnet resides.

Example: my-gcp-project-123

vpc_idstring

The customer-provided VPC ID.

Example: my-vpc-123

subnet_idstring

The customer-provided Subnet ID that will be available to Clusters in Workspaces using this Network.

Example: my-subnet-123

subnet_regionstring

Example: us-east4

pod_ip_range_namestring

Name of the secondary range within the subnet that will be used by GKE as Pod IP range. This is BYO VPC specific. DB VPC uses network.getGcpManagedNetworkConfig.getGkeClusterPodIpRange

Example: my-pod-ip-range-123

service_ip_range_namestring

Name of the secondary range within the subnet that will be used by GKE as Service IP range.

Example: my-service-ip-range-123

List Private Access Settings Public GA

GET /api/2.0/accounts/{account_id}/private-access-settings

Lists <Databricks> private access settings for an account.

API scopes: networking

CloudsAWSGCP

Parameters

account_idstringpath

Response

private_access_settingsarray of object
Show child attributesHide child attributes
private_access_settings_idstring

<Databricks> private access settings ID.

account_idstring

The <Databricks> account ID that hosts the private access settings.

private_access_settings_namestring

The human-readable name of the private access settings object.

regionstring

The AWS region for workspaces attached to this private access settings object.

public_access_enabledboolean

Determines if the workspace can be accessed over public internet. For fully private workspaces, you can optionally specify false, but only if you implement both the front-end and the back-end PrivateLink connections. Otherwise, specify true, which means that public access is enabled.

private_access_levelstring

The private access level controls which VPC endpoints can connect to the UI or API of any workspace that attaches this private access settings object. ACCOUNT level access (the default) allows only VPC endpoints that are registered in your <Databricks> account connect to your workspace. ENDPOINT level access allows only specified VPC endpoints connect to your workspace. For details, see allowed_vpc_endpoint_ids.

Values: ENDPOINT, ACCOUNT

allowed_vpc_endpoint_idsarray of string

An array of Databricks VPC endpoint IDs. This is the <Databricks> ID that is returned when registering the VPC endpoint configuration in your <Databricks> account. This is not the ID of the VPC endpoint in AWS. Only used when private_access_level is set to ENDPOINT. This is an allow list of VPC endpoints that in your account that can connect to your workspace over AWS PrivateLink. If hybrid access to your workspace is enabled by setting public_access_enabled to true, this control only works for PrivateLink connections. To control how your workspace is accessed via public internet, see IP access lists.

List Vpc Endpoint Public GA

GET /api/2.0/accounts/{account_id}/vpc-endpoints

Lists Databricks VPC endpoint configurations for an account.

API scopes: networking

CloudsAWSGCP

Parameters

account_idstringpath

Response

vpc_endpointsarray of object
Show child attributesHide child attributes
vpc_endpoint_idstring

Databricks VPC endpoint ID. This is the <Databricks>-specific name of the VPC endpoint. Do not confuse this with the aws_vpc_endpoint_id, which is the ID within AWS of the VPC endpoint.

account_idstring

The <Databricks> account ID that hosts the VPC endpoint configuration.

vpc_endpoint_namestring

The human-readable name of the storage configuration.

Constraints: [ 4 .. 256 ] characters

aws_vpc_endpoint_idstring

The ID of the VPC endpoint object in AWS.

aws_endpoint_service_idstring

The ID of the <Databricks> endpoint service that this VPC endpoint is connected to. For a list of endpoint service IDs for each supported AWS region, see the Databricks PrivateLink documentation.

use_casestring

This enumeration represents the type of Databricks VPC endpoint service that was used when creating this VPC endpoint. If the VPC endpoint connects to the <Databricks> control plane for either the front-end connection or the back-end REST API connection, the value is GENERAL_ACCESS. If the VPC endpoint connects to the <Databricks> workspace for the back-end secure cluster connectivity relay, the value is DATAPLANE_RELAY_ACCESS.

Values: WORKSPACE_ACCESS, DATAPLANE_RELAY_ACCESS, GENERAL_ACCESS

regionstring

The AWS region in which this VPC endpoint object exists.

aws_account_idstring

The AWS Account in which the VPC endpoint object exists.

statestring

The current state (such as available or rejected) of the VPC endpoint. Derived from AWS. For the full set of values, see AWS DescribeVpcEndpoint documentation.

gcp_vpc_endpoint_infoobjectRequired

The cloud info of this vpc endpoint. Info for a GCP vpc endpoint.

Show child attributesHide child attributes
psc_connection_idstring
GCP

The ID of the underlying PSC Connection in GCP consumer projects. This is assigned by GCP when user sets up the PSC connection in their consumer project on GCP. Read only to users.

project_idstring
GCP

The ID of the GCP consumer project this PSC endpoint is created within.

psc_endpoint_namestring
GCP

The name of this PSC connection in GCP consumer project. This is named by user when user sets up the PSC connection in their consumer project on GCP.

endpoint_regionstring
GCP

The GCP region of the PSC connection endpoint. Currently GCP only supports same region PSC connection, which means the endpoint region needs to be same with the workspace region to build a PSC connection successfully.

service_attachment_idstring
GCP

The ID of the Service Attachment on our Control Plane this PSC endpoint connects to. Read only to users.